#  :memo:全栈工程师笔记



| ☕️    | 💻    | 💾      | 📟        | :globe_with_meridians: | 🌳    | 🚀 | 📊  | :cd: | :books: |
| :----: | :----: | :----: | :----: | :----: | :----: | :----: | :----: | :----: | :----: |
| <a href="#coffee-java">Java</a> | <a href="#-前端">前端</a> | <a href="#-数据库">数据库</a> | <a href="#-操作系统">操作系统</a> | <a href="#-网络通信">网络通信</a>               | <a href="#-Spring">Spring</a> | <a href="#-分布式">分布式</a> | <a href="#-算法和数据结构">算法和数据结构</a> | <a href="#cd-大数据">大数据</a> | <a href="#books-读书笔记">读书笔记</a> |

 

# :coffee: Java

1. Java设计模式

2. Java数据结构

3. 深入理解Java虚拟机

4. 并发编程框架disruptor

5. Java网络编程
6. tomcat 调优



## 💻 前端

TODO



## 💾 数据库

#### 1. Oracle



#### 2. MySQL

+ MySQL 主从复制及读写分离
+ MySQL+keepalived 高可用实践方案
+ MySQL 分库分表
+ 数据库中间件 Mycat

#### 3. Redis

+ redis 简介及基本数据结构
+ redis 管道模式详解
+ redis AOF 和 RDB 持久化策略原理
+ redis 哨兵模式
+ reids 集群模式
+ 缓存击穿、缓存雪崩的解决方案
+ redis 管理客户端cachecloud

#### 4.MongoDB

+ MongoDB 简介及基本原理
+ MongoDB数据类型分析
+ MongoDB 聚合、索引及基本执行命令
+ MongoDB数据分片、转存及恢复策略



## 📟 操作系统

linux 核心概念、常用命令



## 🌐 网络通信

1. IO 基本概念、NIO、AIO、BIO 深入分析
2. 高性能NIO框架Netty



## 🌳 Spring

#### 1.spring 基础

+ AOP
+ IOC
+ Spring事务机制、事务的传播与监控
+ ......

#### 2.spring Boot

+ spring 自动装配原理
+ 理解SpringApplication 
+ Web MVC REST 
+ WebFlux 核心
+ ......



## 🚀 分布式

#### 1. Zookeeper

+ Zookeeper 简介及原理介绍

+ Zookeeper 集群搭建
+ Zookeeper 分布式锁实现方案
+ Zookeeper  集群升级、迁移
+ 深入分析 Zookeeper  Zab协议及选举机制

#### 2. Dubbo 

+ Dubbo 管理中心及监控平台安装部署
+ Dubbo 负载均衡和服务降级

#### 3. Spring Cloud

- Eureka 服务的注册和发现
- Eureka 高可用集群搭建
- Ribbon 客户端负载均衡 RestTemplate 服务远程调用
- OpenFeign 声明式服务调用、服务容错处理
- Hystix 服务容错保护、hystrix dashboard 断路器监控、Turbine 断路器聚合监控
- Zuul 网关服务
- Sleuth + Zipkin 服务链路追踪
- Config 分布式配置中心 、集成Bus消息总线实现配置热更新

#### 4. 消息中间件：Kafka

+ Kafka 简介及消息处理过程分析

+ 基于Zookeeper搭建Kafka高可用集群
+ Kafka 副本机制以及选举原理剖析

#### 5. 消息中间件：RabbitMQ

+ RabbitMQ 简介及消息处理过程分析
+ RabbitMQ 消息确认机制
+ RabbitMQ 如何保证消息的可靠性投递和防止重复消费

#### 6. Nginx

+ Nginx反向代理及负载均衡服务配置实战
+ 利用keeplived+Nginx实现Nginx高可用方案
+ Nginx动静分离实战

#### 7. Docker

+ Docker 基础
+ kubernetes  简介及集群搭建

#### 8.分布式解决方案

+ 全局id生成方案
+ 分布式session解决方案
+ 分布式事务解决方案实战
+ 分布式锁解决方案



## 📊 算法和数据结构

#### 1. 数据结构

数组、栈、队列、链表、二分搜索树、集合、映射、优先队列、堆、线段树、Trie、并查集、AVL、红黑树、哈希表

#### 2. 算法
